mod Ex03b logic: 'cl'

incl Mtex

loc rem 
  3. CVICENIE Z PREDMETU 1-INF-465 DEKLARATIVNE PROGRAMOVANIE

rem 
  VASE MENO: ?
  VERZIA CL: 5.81.16
  DATUM: utorok 28.2.2006
  ******************************************************************************
  MAIL: komara@nw.fmph.uniba.sk
  WWW: http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-INF-465-dp/0506ls/
  ******************************************************************************
  SKUSKA (toto je len zakladny ramec, viz. tiez 1. prednaska):
   A = aspon 90 bodov
   B = aspon 80 bodov
   C = aspon 70 bodov
   D = aspon 60 bodov
   E = aspon 50 bodov

loc rem 
  \para \bf  Uvodna poznamka.  \end Toto cvicenie je venovane binarnej 
  aritmetike a chvostovej rekurzii. 
  \items 
   \item \para Subor \it  mtex.cl  \end obsahuju makra pre CL-TeX. 
   \item \para Subor(y) \it  ex03*.cl  \end obsahuju ulohy, ktore mate riesit na 
         tomto cviceni. 
  \end
  \para Tieto subory sa musia skompilovat v spravnom poradi; presny postup je 
  uvedeny v subore \it  readme.txt  \end. 

fun/0 Foo 'Tex_f0_foo'
  Foo = 0

pred/0 Poo 'Tex_p0_poo'
  Poo <-> \f

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 2001. 
  \end

rem 
  \para \bf  Chapter. Numeric Programs.  \end 

rem 
  \para \bf  Part. Tail Recursion and Iteration.  \end See also 
  \items 
   \item \para the paragraph \it  Fibonacci function  \end in the section \it  
         Primitive Recursion  \end and 
   \item \para the paragraph \it  Simulation of for-loops by recursion  \end in 
         the section \it  Course of Values Recursion  \end. 
  \end

rem 
  \para \bf  Exercise.  \end Find an efficient, tail recursive implementation of 
  the following function: 

fun F1 'Tex_f1_f_sub'
  F1(0) = 0
  F1(1) = 1
  F1(n+2) = F1(n+1)+F1(n)

rem 
  \para \it  While-loop by primitive recursion.  \end 
  \verbatim 
  if n = 0 then return(0)
  else begin
   n,a,b := n-1,1,0;
   while n > 0 do n,a,b := n-1,a+b,a;
   return(a)
  end
  \end

fun/3 While1 'Tex_f3_g'
  While1(n,a,b) = Foo

rem 
  \para Invariant. 
  \eq* 
    While1(n,F1(i+1),F1(i)) = F1(n+1+i)
  \end

fun F1_by_while_loop 'Tex_f1_f_sub'
  F1_by_while_loop(n) = Foo

rem 
  \para \it  For-loop by backward recursion.  \end 
  \verbatim 
  if n = 0 then return(0)
  else if n = 1 then return(1)
  else begin
   n,a,b := n-2,1,0;
   for i = 0 to n do a,b := a+b,a;
   return(a)
  end
  \end

fun/4 For1 'Tex_f4_g'
  For1(n,i,a,b) = Foo

rem 
  \para Invariant. 
  \eq* 
    i <= n+1 -> For1(n,i,F1(i+1),F1(i)) = F1(n+2)
  \end
  \eq* 
    For1(k+i,i,F1(i+1),F1(i)) = F1(k+i+2)
  \end

fun F1_by_for_loop 'Tex_f1_f_sub'
  F1_by_for_loop(n) = Foo

rem 
  \para \bf  Exercise.  \end Find an efficient, tail recursive implementation of 
  the following function: 

fun F2 'Tex_f1_f_sub'
  F2(0) = 0
  F2(1) = 1
  F2(2) = 2
  F2(n+3) = F2(n+2)+F2(n+1)+F2(n)

rem 
  \para \it  While-loop by primitive recursion.  \end 

fun F2_by_while_loop 'Tex_f1_f_sub'
  F2_by_while_loop(n) = Foo

rem 
  \para \it  For-loop by backward recursion.  \end 

fun F2_by_for_loop 'Tex_f1_f_sub'
  F2_by_for_loop(n) = Foo

rem 
  \para \bf  Exercise.  \end Find an efficient, tail recursive implementation of 
  the following function: 

fun F3 'Tex_f1_f_sub'
  F3(0) = 0
  F3(1) = 1
  F3(n+2) = F3(n+1)+F3(n)+n

rem 
  \para \it  While-loop by primitive recursion.  \end 

fun F3_by_while_loop 'Tex_f1_f_sub'
  F3_by_while_loop(n) = Foo

rem 
  \para \it  For-loop by backward recursion.  \end 

fun F3_by_for_loop 'Tex_f1_f_sub'
  F3_by_for_loop(n) = Foo

rem 
  \para \bf  Exercise.  \end Find an efficient, tail recursive implementation of 
  the following function: 

fun F4 'Tex_f1_f_sub'
  F4(0) = 0
  F4(1) = 1
  F4(2) = 2
  F4(n+3) = F4(n+2)+F4(n+1)+F4(n)+n

rem 
  \para \it  While-loop by primitive recursion.  \end 

fun F4_by_while_loop 'Tex_f1_f_sub'
  F4_by_while_loop(n) = Foo

rem 
  \para \it  For-loop by backward recursion.  \end 

fun F4_by_for_loop 'Tex_f1_f_sub'
  F4_by_for_loop(n) = Foo

