mod Ex03a

incl Mtex

loc rem 
  3. CVICENIE Z PREDMETU 1-INF-465 DEKLARATIVNE PROGRAMOVANIE

rem 
  VASE MENO: ?
  VERZIA CL: 5.81.16
  DATUM: utorok 28.2.2006
  ******************************************************************************
  MAIL: komara@nw.fmph.uniba.sk
  WWW: http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-INF-465-dp/0506ls/
  ******************************************************************************
  SKUSKA (toto je len zakladny ramec, viz. tiez 1. prednaska):
   A = aspon 90 bodov
   B = aspon 80 bodov
   C = aspon 70 bodov
   D = aspon 60 bodov
   E = aspon 50 bodov

loc rem 
  \para \bf  Uvodna poznamka.  \end Toto cvicenie je venovane binarnej 
  aritmetike a chvostovej rekurzii. 
  \items 
   \item \para Subor \it  mtex.cl  \end obsahuju makra pre CL-TeX. 
   \item \para Subor(y) \it  ex03*.cl  \end obsahuju ulohy, ktore mate riesit na 
         tomto cviceni. 
  \end
  \para Tieto subory sa musia skompilovat v spravnom poradi; presny postup je 
  uvedeny v subore \it  readme.txt  \end. 

fun/0 Foo 'Tex_f0_foo'
  Foo = 0

pred/0 Poo 'Tex_p0_poo'
  Poo <-> \f

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 2001. 
  \end

rem 
  \para \bf  Chapter. Numeric Programs.  \end 

rem 
  \para \bf  Section. Recursion on Notation.  \end 

rem 
  \para \bf  Subsection. Binary Arithmetic.  \end 

rem 
  \para \bf  [CL] Binary successors.  \end 
  \eq* 
    S0(x) = 2*x+0
  \end
  \eq* 
    S1(x) = 2*x+1
  \end
  \para The functions are defined in the module \ft Standard \end. 

rem 
  \para \bf  [CL] Formatting the output.  \end Use the format \ft Nb \end to 
  display numbers in binary representation. For instance, the result of the 
  query \ft '6=x:Nb' \end is shown as the binary numeral \ft S0 S1 S1(0) \end. 
  Note that the predicate \ft Nb \end is defined in the module 
  \ft Standard \end. 

rem 
  \para \bf  [CL] Binary discrimination.  \end Examples of syntactically correct 
  discrimination: 
  \def 
    fun F 'Tex_f1_f'
    F S0(0) = Foo
    F S0(x) = Foo <- x != 0
    F S1(x) = Foo
  \end
  \def 
    fun F 'Tex_f1_f'
    F S0(x) = Foo <- x = 0
    F S0(x) = Foo <- x != 0
    F S1(x) = Foo
  \end
  \def 
    fun F 'Tex_f1_f'
    F S0(x) = Foo <- x = 0
    F S0(x) = Foo <- x > 0
    F S1(x) = Foo
  \end
  \para Examples of syntactically incorrect discrimination: 
  \def 
    fun F 'Tex_f1_f'
    F(0) = Foo
    F S0(x) = Foo <- x != 0
    F S1(x) = Foo
  \end
  \def 
    fun F 'Tex_f1_f'
    F S0(0) = Foo
    F S0(x) = Foo <- x > 0
    F S1(x) = Foo
  \end

rem 
  \para \bf  Binary size.  \end 

fun Bsz 'Tex_f1_nb_sz'
  Bsz(x) = Foo

rem 
  \para \bf  Program computing the successor function in binary representation. 
   \end 

fun Bsucc 'Tex_f1_nb_succ'
  Bsucc(x) = Foo

rem 
  \para \bf  Program computing the addition function in binary representation. 
   \end 

fun/2 Bplus 'Tex_f2_nb_plus'
  Bplus(x,y) = Foo

rem 
  \para \bf  Exercise.  \end Define the multiplication function \ft x*y \end by 
  binary recursion. 

fun/2 Btimes 'Tex_f2_nb_times'
  Btimes(x,y) = Foo

rem 
  \para \bf  Exercise.  \end Define the exponentiation function 
  \ft Texm_f2_n_exp(x,y) \end by binary recursion. 

fun/2 Bexp 'Tex_f2_nb_exp'
  Bexp(x,y) = Foo

